unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons, ComCtrls, Unit2;

type

  { TFormBodyMassIndex }

  TFormBodyMassIndex = class(TForm)
    BevelTaillenHueftQuotient: TBevel;
    BevelBodyMassIndex: TBevel;
    BitBtnTHQBerechnen: TBitBtn;
    BitBtnBMIBerechnen: TBitBtn;
    EditTaillenumfang: TEdit;
    EditHueftumfang: TEdit;
    EditAlter: TEdit;
    EditGewicht: TEdit;
    EditGroesze: TEdit;
    ImageAuswertungDick: TImage;
    ImageAuswertungDuenn: TImage;
    ImageAuswertungFett: TImage;
    ImageAuswertungNormal: TImage;
    RadioButtonWeiblich: TRadioButton;
    RadioButtonMaennlich: TRadioButton;
    SpeedButtonLizenz: TSpeedButton;
    StaticTextErgebnisTaillenumfang: TStaticText;
    StaticTextAuswertungTHQ: TStaticText;
    StaticTextTHQ: TStaticText;
    StaticTextHueftumfang: TStaticText;
    StaticTextTaillenumfang: TStaticText;
    StaticTextBerechnungBodyMassIndex: TStaticText;
    StaticTextAuswertungOhneAlter: TStaticText;
    StaticTextAuswertungNachAlter: TStaticText;
    StaticTextAlter: TStaticText;
    StaticTextGewicht: TStaticText;
    StaticTextGroesse: TStaticText;
    StaticTextTailleHueftQuotient: TStaticText;
    StaticTextBodyMassIndex: TStaticText;
    StatusBar: TStatusBar;
    procedure BevelTaillenHueftQuotientChangeBounds(Sender: TObject);
    procedure BitBtnBMIBerechnenClick(Sender: TObject);
    procedure BitBtnTHQBerechnenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButtonLizenzClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormBodyMassIndex: TFormBodyMassIndex;

  Groesse,Gewicht,Alter,Taillenumfang,Hueftumfang: Integer;
  BodyMassIndex,SGroesse,SGewicht                : Single;
  STaillenumfang,SHueftumfang,Fettanteil         : Single;
  ErrorSwitch                                    : Boolean;
  
implementation

{ TFormBodyMassIndex }

(*--------------------------- StartInitialisierung ---------------------------*)

procedure TFormBodyMassIndex.FormCreate(Sender: TObject);
begin
  StatusBar.SimpleText:='Gib Daten ein und aktiviere "berechnen"!';
//  ImageAuswertungDuenn.Visible :=False;
//  ImageAuswertungNormal.Visible:=False;
//  ImageAuswertungDick.Visible  :=False;
//  ImageAuswertungFett.Visible  :=False;
End;

(*--------------------------- Anzeige Hilfe / Lizenz -------------------------*)

procedure TFormBodyMassIndex.SpeedButtonLizenzClick(Sender: TObject);
begin
  FormInfo.ShowModal;
end;

(*--------------------------- Berechnung BMI ---------------------------------*)

procedure TFormBodyMassIndex.BitBtnBMIBerechnenClick(Sender: TObject);
begin
  ErrorSwitch:=False;
  Try                                                          // EingabePrfung
    Groesse:=StrToInt(EditGroesze.Text);
  Except
    On EConvertError Do
      Begin
        StatusBar.SimpleText:='Die Daten muessen numerisch sein!';
        ShowMessage('Fehler: Eingabe der Groesse fehlerhaft!');
        ErrorSwitch:=True;
      End;
  End;

  Try
    Gewicht:=StrToInt(EditGewicht.Text);
  Except
    On EConvertError Do
      Begin
        StatusBar.SimpleText:='Die Daten muessen numerisch sein!';
        ShowMessage('Fehler: Eingabe des Gewichtes fehlerhaft!');
        ErrorSwitch:=True;
      End;
  End;

  Try
    Alter:=StrToInt(EditAlter.Text);
  Except
    On EConvertError Do
      Begin
        StatusBar.SimpleText:='Die Daten muessen numerisch sein!';
        ShowMessage('Fehler: Eingabe des Alters fehlerhaft!');
        ErrorSwitch:=True;
      End;
  End;

  If (Groesse<50) Or (Groesse>230) Then
    Begin
      StatusBar.SimpleText:='Die Groesse muss zwischen 50 und 230 cm liegen!';
      ShowMessage('Zwerge und Riesen werden nicht berechnet!');
      ErrorSwitch:=True;
    End;

  If (Gewicht<30) Or (Gewicht>150) Then
  Begin
    StatusBar.SimpleText:='Das Gewicht muss zwischen 30 und 150 kg liegen!';
    ShowMessage('Maeuse und Elefanten werden nicht berechnet !');
    ErrorSwitch:=True;
  End;

  If (Alter<19) Or (Alter>99) Then
  Begin
    StatusBar.SimpleText:='Das Alter muss zwischen 19 und 99 Jahren liegen!';
    ShowMessage('Saeuglinge und Mumien werden nicht berechnet !');
    ErrorSwitch:=True;
  End;

  If Not Errorswitch Then
    Begin                                                       //Berechnung BMI
      SGroesse:=Groesse; SGewicht:=Gewicht;// schaltet Konvertierungswarnungen aus
      BodyMassIndex:=((SGewicht/(SGroesse*SGroesse))*10000)+0.05;         // BMI
      BitBtnBMIBerechnen.Caption:=FormatFloat(' ##.0',BodyMassIndex);

                                                        // ImageAuswertungNormal nach Alter
  
      If ((Alter>18) And (Alter<25) And (BodyMassIndex>18.9) And (BodyMassindex<24.1)) Or
         ((Alter>24) And (Alter<35) And (BodyMassIndex>19.9) And (BodyMassindex<25.1)) Or
         ((Alter>34) And (Alter<45) And (BodyMassIndex>20.9) And (BodyMassindex<26.1)) Or
         ((Alter>44) And (Alter<55) And (BodyMassIndex>21.9) And (BodyMassindex<27.1)) Or
         ((Alter>54) And (Alter<65) And (BodyMassIndex>22.9) And (BodyMassindex<28.1)) Or
         ((Alter>64) And                (BodyMassIndex>23.9) And (BodyMassindex<29.1)) Then
          Begin
            StaticTextAuswertungNachAlter.Caption:='Auswertung nach Alter: Normalgewicht';
            ImageAuswertungNormal.Visible:=True;
            ImageAuswertungDuenn.Visible :=False;
            ImageAuswertungDick.Visible  :=False;
            ImageAuswertungFett.Visible  :=False;
          End                                                                          Else
      If ((Alter>18) And (Alter<25) And (BodyMassIndex<19.0)) Or
         ((Alter>24) And (Alter<35) And (BodyMassIndex<20.0)) Or
         ((Alter>34) And (Alter<45) And (BodyMassIndex<21.0)) Or
         ((Alter>44) And (Alter<55) And (BodyMassIndex<22.0)) Or
         ((Alter>54) And (Alter<65) And (BodyMassIndex<23.0)) Or
         ((Alter>64) And                (BodyMassIndex<24.0)) Then
          Begin
            StaticTextAuswertungNachAlter.Caption:='Auswertung nach Alter: Untergewicht';
            ImageAuswertungDuenn.Visible :=True;
            ImageAuswertungNormal.Visible:=False;
            ImageAuswertungDick.Visible  :=False;
            ImageAuswertungFett.Visible  :=False;
          End                                                Else
      If ((Alter>18) And (Alter<25) And (BodyMassIndex>24.0)) Or
         ((Alter>24) And (Alter<35) And (BodyMassIndex>25.0)) Or
         ((Alter>34) And (Alter<45) And (BodyMassIndex>26.0)) Or
         ((Alter>44) And (Alter<55) And (BodyMassIndex>27.0)) Or
         ((Alter>54) And (Alter<65) And (BodyMassIndex>28.0)) Or
         ((Alter>64) And                (BodyMassIndex>29.0)) Then
          Begin
            StaticTextAuswertungNachAlter.Caption:='Auswertung nach Alter: Uebergewicht';
            ImageAuswertungDick.Visible  :=True;
            ImageAuswertungDuenn.Visible :=False;
            ImageAuswertungNormal.Visible:=False;
            ImageAuswertungFett.Visible  :=False;
          End;

      If BodyMassIndex>40 Then
        Begin
          StaticTextAuswertungNachAlter.Caption:='Auswertung nach Alter: gefaehrliches Uebergewicht';
          ImageAuswertungFett.Visible  :=True;
          ImageAuswertungDuenn.Visible :=False;
          ImageAuswertungNormal.Visible:=False;
          ImageAuswertungDick.Visible  :=False;
        End;

                                                   // ImageAuswertungNormal ohne Alter
      If BodyMassIndex < 18.5 Then
          StaticTextAuswertungOhneAlter.Caption:='Auswertung ohne Alter: Untergewicht'
                              Else
      If ((BodyMassIndex>18.4) and (BodyMassindex<25.0)) Then
          StaticTextAuswertungOhneAlter.Caption:='Auswertung ohne Alter: Normalgewicht'
                                                         Else
      If ((BodyMassIndex>24.9) and (BodyMassindex<30.0)) Then
          StaticTextAuswertungOhneAlter.Caption:='Auswertung ohne Alter: Uebergewicht'
                                                         Else
           StaticTextAuswertungOhneAlter.Caption:='Auswertung ohne Alter: gefaehrliches Uebergewicht';
    End;
  ErrorSwitch:=False;
end;

procedure TFormBodyMassIndex.BevelTaillenHueftQuotientChangeBounds(
  Sender: TObject);
begin

end;

(*--------------------------- Berechnung THQ ---------------------------------*)

procedure TFormBodyMassIndex.BitBtnTHQBerechnenClick(Sender: TObject);

begin
  Try                                                          // EingabePrfung
    Taillenumfang:=StrToInt(EditTaillenumfang.Text);
  Except
    On EConvertError Do
      Begin
        StatusBar.SimpleText:='Die Daten muessen numerisch sein!';
        ShowMessage('Fehler: Eingabe des Taillenumfangs fehlerhaft!');
        ErrorSwitch:=True;
      End;
  End;

  Try
    Hueftumfang:=StrToInt(EditHueftumfang.Text);
  Except
    On EConvertError Do
      Begin
        StatusBar.SimpleText:='Die Daten muessen numerisch sein!';
        ShowMessage('Fehler: Eingabe des Hueftumfangs fehlerhaft!');
        ErrorSwitch:=True;
      End;
  End;

  If (Taillenumfang<30) or (Taillenumfang>200) Then
     Begin
       StatusBar.SimpleText:='Taillenumfang muss zwischen 30 und 200 cm liegen!';
       ShowMessage('Bleistifte und Tonnen werden nicht berechnet!');
       ErrorSwitch:=True;
     End;

  If (Hueftumfang<30) or (Hueftumfang>200) Then
    Begin
      StatusBar.SimpleText:='Hueftumfang muss zwischen 30 und 200 cm liegen!';
      ShowMessage('Bohnenstangen und Fettmoepse werden nicht berechnet!');
      ErrorSwitch:=True;
    End;

  If Not ErrorSwitch Then
    Begin                                                      // Berechnung THQ
      STaillenumfang:=Taillenumfang; SHueftumfang:=Hueftumfang;
      Fettanteil:=(Taillenumfang / Hueftumfang) + 0.005;
      BitBtnTHQBerechnen.Caption:=FormatFloat('   0.00',Fettanteil);

      If (RadioButtonMaennlich.Checked=True) And (Fettanteil<1.1) Then
          StaticTextAuswertungTHQ.Caption:='Auswerung TailleHueftQuotient: normal'
                                                                  Else
      If (RadioButtonMaennlich.Checked=True) And (Fettanteil>1.0) Then
          StaticTextAuswertungTHQ.Caption:='Auswertung TailleHueftQuotient: unnormal'
                                                                  Else
      If (RadioButtonWeiblich.Checked=True) And (Fettanteil<0.86) Then
          StaticTextAuswertungTHQ.Caption:='Auswertung TailleHueftQuotient: normal'
                                                                  Else
      If (RadioButtonWeiblich.Checked=True) And (Fettanteil>0.85) Then
          StaticTextAuswertungTHQ.Caption:='Auswertung TailleHueftQuotient: unnormal';

                                                                // Taillenumfang

      If (RadioButtonMaennlich.Checked=True) And (Taillenumfang>94) Then
          StaticTextErgebnisTaillenumfang.Caption:='Auswertung Taillenumfang: bedenklich'
                                                                    Else
      If (RadioButtonWeiblich.Checked=True) And (Taillenumfang>85)  Then
          StaticTextErgebnisTaillenumfang.Caption:='Auswertung Taillenumfang: bedenklich'
                                                                    Else
          StaticTextErgebnisTaillenumfang.Caption:='Auswertung Taillenumfang: normal';
    End;
  ErrorSwitch:=False;
end;

(*----------------------------------------------------------------------------*)

Initialization
  {$I Unit1.lrs}
end.
